<?
/*
 *	version : 1.5.0 dev
 *	file name : mgboard.php
 *	this program made by Lee Han-gil.
 *	start date : 2003 - 02 - 15
 *	
 *	jedit option
 *	:folding=explicit:collapseFolds=1:
 */
	//include "./resource.php";
	include "../ListDatabase/ListDatabase.php";
	
	informationLoad();
	configLoad();
	skinConfigLoad();
	$ldb = new ListDatabase('./system/database/'.$bdbn);
	$ldb->openLDB("w");
	process();
	$ldb->closeLDB();

//{{{Լ makeIP2Number($ip)///makeNumber2IP($number)
	function makeIP2Number($ip)
	{
		$first = strtok($ip, '.');
		$second = strtok('.');
		$third = strtok('.');
		$forth = strtok('');
		return $first*256*256*256+$second*256*256+$third*256+$forth;
	}
	function makeNumber2IP($number)
	{
		$first = (int)($number/256*256*256);
		$second = (int)(($number%(256*256*256))/(256*256));
		$third = (int)($number%(256*256)/256);
		$forth = (int)($number%256);
		return $first.'.'.$second.'.'.$third.'.'.$forth;
	}
//}}}
//{{{Լ setOption($mentn, $html, $secret) / get
	function setOption($mentn, $html, $secret)
	{
		return $mentn*100+$html*10+$secret;
	}
	function getOption($opt)
	{
		// ment, html, secret
		return array($opt/100, $opt%100/10, $opt%1000);
	}
//}}}
//{{{Լ setNameEmail($name, $email) / get
	function setNameEmail($name, $email)
	{
		return urlencode($name).'='.urlencode($email);
	}
	function getNameEmail($nameEmail)
	{
		return array(urldecode(strtok($NameEmailPasswd, '=')), urldecode(strtok('')));
	}
//}}}
//{{{Լ set/getFileNameType($file)
	function setFileNameType($name, $type)
	{
		return urlencode($name).'='.urlencode($type);
	}
	function getFileNameType($file)
	{
		return array(urldecode(strtok($file, '=')), urldecode(strtok('')));
	}
//}}}

//{{{Լ list, search
	function lst()
	{
		global $ldb;
		global $page;		// out
		global $CONFIG;
		global $bdbn;		// in (variable from function named informationLoad)
		
		// get total data
		$TOTAL = $ldb->getTotalRow();
		
		// get total page
		$TOTAL_PAGE = (int)($TOTAL/$CONFIG[onepagen]);
		if ( $TOTAL%$CONFIG[onepagen] != 0 ) $TOTAL_PAGE++;
		
		// set now list page
		if ( $page == 0 || $page == "" ) $page=$TOTAL_PAGE;
		
		// make list
		$start = ($TOTAL_PAGE-$page)*$CONFIG[onepagen];
		$first = $ldb->getNnd($TOTAL-$start);
		if ( $first != 0 )
		{
			$list[0] = $first;
			for ( $i=1 ; $i<$CONFIG[onepagen] ; $i++ )
			{
				$list[$i] = $ldb->getBeforeRow($list[$i-1]);
				if ( $list[$i] == 0 ) break;
			}
		}
		
		showList($list);
	}
	function search()
	{
		
	}
	function showList($list)
	{
		global $ldb;
		global $id;
		global $SKIN;
		global $CONFIG;
		global $noticePs;	// in (variable from function named informationLoad)
		
		$list_n = count($list);
		$NEW_LINK = './mgboard.php?id='.$id.'&a=nw';
		$ID = $id;
		include "./skin/$CONFIG[skin]/head.php";
		include "./skin/$CONFIG[skin]/list_head.php";
		
		// need : notice view
		
		if ( $list_n == 0 )
		{
			?>
			<TR>
				<TD colspan="<?=$TD?>" align="center">Խù  ʽϴ.</TD>
			</TR>
			<?
		}
		for ( $i=0 ; $i<$list_n ; $i++  )
		{
			list ($name, $email, $home, $title, $filename, $filetype, $filesize, $hit, $down, $mentn, $html, $secret)
				= readRow($list[$i]);
			
			$titleURL = './mgboard.php?id='.$id.'a=v&n='.$list[$i];
			if ( $email!='' ) $nameURL = 'mailto:'.$email;
			
			include "./skin/$CONFIG[skin]/list_view.php";
		}
		include "./skin/$CONFIG[skin]/list_foot.php";
		include "./skin/$CONFIG[skin]/foot.php";
	}
//}}}

//{{{Լ : readRow($n)
	function readRow($n)
	{
		list ($name,$email) = getNameEmail( $ldb->getValue($n, 'name_email') );
		$home = $ldb->getValue($n, 'home');
		$title = $ldb->getValue($n, 'title');
		list ($filename,$filetype) = getFileNameType($ldb->getValue($n, 'file'));
		$filesize = $ldb->getValue($n, 'filesize');
		$hit = $ldb->getValue($n, 'hit');
		$down = $ldb->getValue($n, 'down');
		list ($mentn, $html, $secret ) = getOption($ldb->getValue($n, 'opt'));
		return array($name, $email, $home, $title, $filename, $filetype, $filesize, $hit, $down, $mentn, $html, $secret);
		// without $content, $ment_psn, $ip, $passwd
	}
//}}}

//{{{Լ v, mv
	// ?id= &a=view&r =[ȸ Խù ȣ]
	function view($n)
	{
		global $ldb;
		global $SKIN;
		
		list ($name, $email, $home, $title, $filename, $filetype, $filesize, $hit, $down, $mentn, $html, $secret)
				= readRow($list[$i]);
		
		$content = $ldb->getValue($n, 'text');
		
		if ( $secret == 1 )
		{
			// cannot view;
		}
		
		include "./skin/$CONFIG[skin]/view.php";
	}
	function v()
	{
		global $CONFIG;
		global $r;			// out (get)
		global $id;
		
		list ($mentn, $html, $secret ) = getOption($ldb->getValue($n, 'opt'));
		if ( $secret == 1 )
		{
			$n = $r;
			$re = $ldb->getValue($n, 're');
			if ( $re == 1 ) $n = $ldb->getNextRow($n);
			$passwd = $ldb->getValue($n, 'passwd');
			
			if ( !passCheck($passwd, "in") )
			{
				passwdForm("Ͻ  бԴϴ.  ۼ Է н带 Էּ.");
			}
		}
		
		if ( HitCheck("hit_$id*$r") )
		{
			$hit = $ldb->getValue($r, 'hit');
			$ldb->setValue($r, 'hit', $hit+1);
		}
		
		include "./skin/$CONFIG[skin]/head.php";
		view($r);
		include "./skin/$CONFIG[skin]/foot.php";
	}
	function mv()
	{
		global $CONFIG;
		global $r;			// out (get)
		
		include "./skin/$CONFIG[skin]/head.php";
		view($r[0]); // <- multi process
		include "./skin/$CONFIG[skin]/foot.php";
	}
//}}}

//{{{Լ nw, rep, mdf
	function nw()
	{
		global $id;
		global $CONFIG;
		
		if ( $CONFIG[isWriteOnlyAdmin]=='checked' )
		{
			if ( !passCheck($CONFIG[passwd], "in") )
			{
				passwdForm("ڸ  ۼ  ֽϴ");
			}
		}
		
		$ID=$id;
		$A='ns';
		global $SKIN;
		include "./skin/$CONFIG[skin]/head.php";
		include "./skin/$CONFIG[skin]/write.php";
		include "./skin/$CONFIG[skin]/foot.php";
	}
	function rep()
	{
		global $id;
		global $ldb;
		global $r;			// out (get)
		
		if ( $CONFIG[isReplyOnlyAdmin]=='checked' )
		{
			if ( !passCheck($CONFIG[passwd], "in") )
			{
				passwdForm("ڸ 亯 ۼ  ֽϴ");
			}
		}
		
		list ($name, $email, $home, $title, $filename, $filetype, $filesize, $hit, $down, $mentn, $html, $secret)
				= readRow($list[$i]);
		
		$content = $ldb->getValue($n, 'text');
		
		$ID=$id;
		$A='rs';
		$R=$r;
		global $SKIN;
		include "./skin/$CONFIG[skin]/head.php";
		include "./skin/$CONFIG[skin]/write.php";
		include "./skin/$CONFIG[skin]/foot.php";
	}
	function mdf()
	{
		global $id;
		global $ldb;
		
		$passwd = $ldb->getValue($n, 'passwd');
		if ( !passCheck($passwd, "in") )
		{
			passwdForm(" ۼ Է н带 Էֽñ ٶϴ.");
		}
		
		list ($name, $email, $home, $title, $filename, $filetype, $filesize, $hit, $down, $mentn, $html, $secret)
				= readRow($list[$i]);
		
		$content = $ldb->getValue($n, 'text');
		
		$ID=$id;
		$A='ms';
		$R=$r;
		global $SKIN;
		include "./skin/$CONFIG[skin]/head.php";
		include "./skin/$CONFIG[skin]/write.php";
		include "./skin/$CONFIG[skin]/foot.php";
	}
	
//}}}

//{{{Լ ns, rs, ms
	function ns()
	{
		global $ldb;
		global $CONFIG;
		
		if ( $CONFIG[isWriteOnlyAdmin] == 'checked' )
		{
			if ( !passCheck($CONFIG[passwd], "coo") )
			{
				message("ڸ  ۼ  ֽϴ");
			}
		}
		checkFields();
		fs($ldb->insertRow(-1));
		
		$ldb->setValue($r, 're', 0);
	}
	function rs()
	{
		global $ldb;
		global $CONFIG;
		global $r;		// out(post)
		
		if ( $CONFIG[isReplyOnlyAdmin] == 'checked' )
		{
			if ( !passCheck($CONFIG[passwd], "coo") )
			{
				message("ڸ 亯 ۼ  ֽϴ");
			}
		}
		
		checkFields();
		$psN=$ldb->getBeforeRow($r);
		fs($ldb->insertRow($psN));
		
		$ldb->setValue($r, 're', $ldb->getValue($r, 're')+1);
	}
	function ms()
	{
		global $ldb;
		global $CONFIG;
		global $r;		// out(post)
		
		$passwd = $ldb->getValue($r, 'passwd');
		if ( !passCheck($CONFIG[passwd], "coo") )
		{
			message(" ۼ  Է н尡 ʿմϴ.");
		}
		
		checkFields();
		fs($r);
	}
	
	function fs($r)
	{
		global $name;
		global $email;
		global $home;
		global $title;
		global $content;
		global $file;
		global $file_name;
		global $file_type;
		global $file_size;
		global $html;
		global $secret;
		global $passwd;
		
		$ldb->setValue($r, 'name_email', setNameEmail($name, $email));
		$ldb->setValue($r, 'home', $home);
		$ldb->setValue($r, 'title', $title);
		$ldb->setValue($r, 'text', $content);
		$ldb->setValue($r, 'file', setFileNameType($file_name, $file_type));
		$ldb->setValue($r, 'filesize', $file_size);
		$ldb->setValue($r, 'hit', 0);
		$ldb->setValue($r, 'down', 0);
		$ldb->setValue($r, 'opt', setOption(0, $html, $secret));
		$ldb->setValue($r, 'ment_spn', 0);
		$ldb->setValue($r, 'ip', makeIP2Number($REMOTE_ADDR));
		$ldb->setValue($r, 'passwd' , $passwd);
	}
	
	function checkFields()
	{
		global $name;
		global $email;
		global $home;
		global $title;
		global $content;
		global $file;
		global $ftype;
		global $file_type;
		global $file_size;
		global $html;
		global $secret;
		global $passwd;
		
		
		if ( eregi($con_admin, $name) == 1 )
			if ( !(PassCheck('', 'in') || PassCheck('', 'coo')) )
				message("Ī<br><br> ̸ Ե ̸  ø  ϴ.");
		
		if ( trim($name) == "" || trim($title) == "" || trim($content) == "" )
			message("ִ ʵ尡 ֽϴ.<br><br>name, title, content  ʵ尡 ִ Ȯֽʽÿ.");
		
		$emailcheck = EmailCheck($email);
		if ( $emailcheck != "" ) message('̸ ּҿ  ֽϴ.<br><br>'.$emailcheck);
		
		if ( strlen($name) >$CONFIG[nameLen] )
			message('name ̰ ʹ ϴ.<br><br>'.$con_name_len.'  ̷ ۼֽñ ٶϴ.');
		
		if ( strlen($title) >$CONFIG[titleLen] )
			message('title ̰ ʹ ϴ.<br><br>'.$con_title_len.'  ̷ ۼֽñ ٶϴ.');
		
		if ( ($upfile_size/1024) > $CONFIG[upfileSize] )
			message('÷ ũⰡ ʹ Ůϴ.<br><br>'.$con_upfilesize.'   ε ֽñ ٶϴ.');
		
		if ( $ftype == "image" )
			if ( $file_type!="image/pjpeg" && $file_type!="image/gif" && $file_type!="image/x-png" )
				message('ε  ° ٸ ʽϴ.<br><br>̹(jpg/gif/png) ÷  ִ Խ Դϴ.');
		
		setcookie("coo_name", $name, time()+864000);
		setcookie("coo_home", $home, time()+864000);
		setcookie("coo_email", $email, time()+864000);
	}
//}}}

//{{{Լ unlink
	function ur()
	{
	}
//}}}

//{{{Լ config, cs
	function config()
	{
	}
	function cs()
	{
	}
//}}}

//{{{Լ mts, mtu
	function mts()
	{
	}
	function mtu()
	{
	}
//}}}

//{{{Լ gf, vf, outFile
	function gf()
	{
	}
	function vf()
	{
	}
	function outFile()
	{
	}
//}}}

//Լ process() : Ѿ $a  ʿ Լ Ų.
	function process()
	{
		global $a;		// out(get)
		
		$actSet = array
			(
				"lst",			// board list
				"search",		// search
				"v",			// view row
				"mv",			// multi view
				"nw",			// new write form
				"rep",		// reply write form
				"mdf",		// modify write form
				"ns",			// new wirte save
				"rs",			// reply wirte save
				"ms",			// modify write save
				"ur",			// unlink
				"config",		// skin config form
				"cs",			// skin config save
				"mts",		// ment save
				"mtu",		// ment unlink
				"gf",			// get file
				"vf",			// view file
			);
		
		if ( $a == "" ) lst();
		else
		{
			$check=0;
			$actSetSize = count($actSet);
			for ( $i=$actSetSize; $i!=0 ; $i-- )
			{
				if ( $a == $actSet[$i] )
				{
					$a();
					$check=1;
					break;
				}
			}
			if ( $check==0 ) message("Ѿ  ڰ ߸Ǿϴ");
		}
	}
	
//{{{Լ skinConfigLoad():Ų ȯ  о´.
	function skinConfigLoad()
	{
		// $skin[key] = value;
		global $id;			// out (get)
		global $CONFIG;		// in (configLoad)
		global $SKIN;		// in (skinConfigLoad)
		
		$path = './system/skinconfig/'.$CONFIG[skin].".".$id;
		if ( !file_exists ($path) ) $path = './skin/'.$CONFIG[skin].'/default.config';
		$buf = file($path);
		for ( $i=0 ; $i<count($buf) ; $i++ )
		{
			$key = strtok($buf[$i], '=');
			$value = chop(stripslashes(strtok('')));
			$SKIN[$key] = $value;
		}
	}
//}}}

//{{{Լ informationLoad():Ѿ id  Խ  о´
	function informationLoad()
	{
		global $id;			// out (get)
		global $bdbn;		// in (this)
		global $noticePs;	// in (this)
		global $configPs;	// in (this)
		
		$ldb = new ListDatabase("./system/database/_mb_system_");
		if ( !$ldb->openLDB("r") ) message("Խ ġ ʾҰų ջǾϴ. ٽ ġϰ õֽñ ٶϴ.");
		
		$bdbn = $ldb->getValue($id, "bdbn");
		
		if ( $bdbn == "" ) message("  Խ ͺ̽ ̵ Դϴ. ٽ ϰ õֽñ ٶϴ.");
		
		$noticePs = $ldb->getValue($id, "notice_spn");
		$configPs = $ldb->getValue($id, "config_spn");
		$ldb->closeLDB();
	}
//}}}
	
//{{{Լ configLoad():Խ ȯ漳 о´
	function configLoad()
	{
		global $id;			// out (get)
		global $configPs;	// in (informationLoad)
		global $CONFIG;		// in (this)
		
		$ldb = new ListDatabase("./system/database/_mb_config_");
		if ( !$ldb->openLDB("r") ) message("Խ ġ ʾҰų ջǾϴ. ٽ ġϰ õֽñ ٶϴ.");
		
		$ps = $configPs;
		while( $ps != 0 && $ldb->getValue($ps, "id") == $id )
		{
			$key = $ldb->getValue($ps, "key");
			$value = $ldb->getValue($ps, "value");
			if ( $key != '' ) $CONFIG[$key] = $value;
			$ps = $ldb->getNextRow($ps);
		}
		
		if ( empty($CONFIG[skin]) ) $CONFIG[skin] = 'default';
		if ( empty($CONFIG[onepagen]) ) $CONFIG[onepagen] = 10;
		if ( empty($CONFIG[passwd]) ) $CONFIG[passwd] = 1234;
	}
//}}}

//{{{Լ message($MESSAGE): ߻Ҷ  ޽ Ѹ /// passwdForm($MESSAGE)
	function message($MESSAGE)
	{
		global $CONFIG;
		include "./skin/$CONFIG[skin]/head.php";
		include "./skin/$CONFIG[skin]/message.php";
		include "./skin/$CONFIG[skin]/foot.php";
		exit(0);
	}
	
	function passwdForm($MESSAGE)
	{
		global $CONFIG;
		include "./skin/$CONFIG[skin]/head.php";
		include "./skin/$CONFIG[skin]/message.php";
		include "./skin/$CONFIG[skin]/foot.php";
		exit(0);
	}
//}}}

/*ּ : Խ ⺻ ׿  
	
	 Ѱ ޱ..
		?id=&a=& ... 
	
	Խ  丮
		./mgboard.php
		./resource.php
		./system/database/
		./system/comment/
		./system/upfile/
		./system/skinconfig/
	
	ü  database ´.
		
		ù°  Խ database ̸  Ѵ.
			db name : _mb_system_
			table struct :
				bdbn(string)		Խ ͺ̽ ̸
				notice_spn(number)	Խ  ġ
				config_spn(number)	Խ ȯ漳  ġ 
				
		ι°  Խǵ  Ѵ.
			db name : _mb_notice_
			table struct :
				title(string)			 ŸƲ
				content(string)		 
				upfile(string)		 ÷
				hit(number)		 Ŭ
				id(number)			Խ id
				
		°  Խǵ ȯ漳 Ѵ.
			db name : _mb_config_
			table struct :
				key(string)			 Ű
				value(string)		 Ű  
				id(number)			Խ id
			$CONFIG{key}=value;   
			...
			$CONFIG[name]
			$CONFIG[email]
			$CONFIG[home]
			$CONFIG[onepagen]
			$CONFIG[skin]
			$CONFIG[nameLen]
			$CONFIG[titleLen]
			$CONFIG[titleReduceLen]
			$CONFIG[reHead]
			$CONFIG[reFoot]
			$CONFIG[upfileSize]
			$CONFIG[isReMail]
			$CONFIG[isUseMent]
			$CONFIG[isWriteOnlyAdmin]
			$CONFIG[isReplyOnlyAdmin]
			
	Խ ͺ̽
		name_email (s)
		home (s)
		title (s)
		text (s)
		file (s)
		filesize (n)
		hit (n)
		down (n)
		opt (n)		$mentn*100 + $html*10 + $secret
		ment_spn (n)
		ip (n)
		passwd (s)
		re (n)
		
	Խ ڸƮ ͺ̽
		name_email (s)
		ment (s)
		passwd (s)
		ori_bdn (n)
*/
	function EmailCheck($email)
	{
		if ( trim($email) == "" ) return;
		if (strpos($email, '@') == false || strpos($email, '@') != strrpos($email, '@')) $error = "@   ߸Ǿϴ. <br>";
		$address = explode('@', $email);
		if ( !ereg("^[a-zA-Z]", $address[0], $temp) ) $error .= "ù ڴ   ̾ մϴ.<br>";
		if ( !((strlen($address[0]) >= 4) && (strlen($address[0]) <= 12)) ) $error .= "ڰ ̰ 4~12  Ѿϴ.<br>";
		if ( ereg("[^-_a-zA-Z0-9]", $address[0], $temp) ) $error .= "ڰ   '-', '_'  ̿ܿ   ϴ.<br>";
		if ( !ereg(".", $address[1], $temp) ) $error .= "ּҿ '.' ڰ ϴ.<br>";
		if ( ereg("[^-_.a-zA-Z0-9]", $address[1], $temp) ) $error .= "ּҴ , ,  ̿ܿ   ϴ.<br>";
		return $error;
	}
	
	function passCheck($source, $mode)
	{
		global $CONFIG;
		
		global $passwd;
		global $coo_pass;
		
		if ( $source == "" ) $source = $con_admin_pw;
		
		if ( ($source == $passwd||$CONFIG[passwd] == $passwd) && $mode == "in" )
		{
			setcookie("coo_pass", $source);
			return true;
		}
		else if ( ($source == $coo_pass||$CONFIG[passwd] == $passwd) && $mode == "coo" )
		{
			setcookie("coo_pass");
			return true;
		}
		else
		{
			setcookie("coo_pass");
			return false;
		}
	}
	
	function hitCheck($name)
	{
		global $$name;
		
		if ( $$name == "read" )
		{
			return false;
		}
		else
		{
			setcookie($name, "read");
			return true;
		}
	}
?>
